	; Sum up some decimal values, return result in errorlevel
	; (low byte of result, actually). Public Domain by Eric Auer.
	org 100h

start:	mov si,81h		; command line start
	cld
	xor bp,bp		; nonzero if next number negative
	xor di,di		; count of given arguments
	xor cx,cx		; the sum

scan:	lodsb
	cmp al,13		; end?
	jz eol
	cmp al,0		; end?
	jz eol
	cmp al,' '
	jz scan
	cmp al,9		; tab?
	jz scan
	cmp al,'+'
	jz scan			; ignore explicit + sign
	cmp al,'-'
	jnz nonnegative
; negative:
	xor bp,1		; toggle neg flag
	jmp short scan

nonnegative:
	cmp al,'0'
	jb help
	cmp al,'9'
	ja help
	jmp number


help:	mov dx,helpmsg
	mov ah,9
	int 21h
	mov ax,4c00h
	int 21h


eol:	mov ax,cx		; fetch sum
	or di,di		; any values involved?
	jz help			; else complain
	;
	push ax
	mov ax,di		; will be at most 63, cmd line len limits
	aam			; AH=AL/10, AL=AL%10
	add ax,'00'
	xchg al,ah
	mov [numargs],ax
	pop ax
	push ax			; start processing the result for display
	mov byte [thevalue],'+'
	or ax,ax
	jns nonegresult
	mov byte [thevalue],'-'
	neg ax			; convert to positive
nonegresult:
	xor dx,dx
	mov bx,10000
	div bx
	add al,'0'
	mov [thevalue+1],al	; 10000s digit
	mov ax,dx		; use remainder for lower digits
	xor dx,dx
	mov bx,100
	div bx
	aam			; AH=AL/10, AL=AL%10
	add ax,'00'
	xchg al,ah
	mov [thevalue+2],ax	; middle 2 digits
	mov ax,dx		; lowest 2 digits
	aam			; AH=AL/10, AL=AL%10
	add ax,'00'
	xchg al,ah
	mov [thevalue+4],ax	; middle 2 digits
	cmp byte [numargs],'0'
	jnz nosmallna
	mov byte [numargs],' '	; suppress leading 0
nosmallna:
	mov ah,[thevalue]	; sign
	mov si,thevalue+1	; offset
	lodsb
	cmp al,'0'
	jnz alllead0done
	mov byte [si-2],' '	; wipe sign at old place
	mov [si-1],ah		; write sign at new place
	lodsb
	cmp al,'0'
	jnz alllead0done
	mov byte [si-2],' '	; wipe sign at old place
	mov [si-1],ah		; write sign at new place
	lodsb
	cmp al,'0'
	jnz alllead0done
	mov byte [si-2],' '	; wipe sign at old place
	mov [si-1],ah		; write sign at new place
	lodsb
	cmp al,'0'
	jnz alllead0done
	mov byte [si-2],' '	; wipe sign at old place
	mov [si-1],ah		; write sign at new place
alllead0done:
	mov dx,resultmsg
	mov ah,9
	int 21h
	pop ax
	;
	mov ah,4ch		; sorry, gotta zap the high byte
	int 21h			; return sum as errorlevel


number:	xor bx,bx		; the number
	dec si			; rewind to start of number
nloop:	lodsb
	cmp al,' '		; end of argument or buffer?
	jbe ndone
	sub al,'0'		; convert to binary
	cmp al,9		; a valid digit?
	ja nwrongchar
	mov ah,0		; (!)
	cmp bx,(32768+9)/10	; will become > 32767 now
	jae noverflow
	push ax
	push dx			; protect DX from MUL...!
	mov ax,10		; multiply old value by 10
	xor dx,dx
	mul bx
	mov bx,ax		; update intermediate result
	pop dx
	pop ax
	add bx,ax		; add the new digit as lowest one
	jmp short nloop		; scan for more digits

nwrongchar:
	mov ah,9
	mov dx,wrongcharmsg
	int 21h
	inc si			; "undo the upcoming rewind in advance"
	jmp short ndone		; continue anyway, accept number

noverflow:
	mov ah,9
	mov dx,overflowmsg
	int 21h
	jmp scan		; continue, but throw away number


ndone:	cmp bx,32767		; e.g. 32769 not detected yet
	ja noverflow
	dec si			; un-read space after the number
	inc di			; count number of values
	or bp,bp		; negative sign to be used?
	jnz subtraction
; addition:
	add cx,bx
	jmp scan		; find next number or end...

subtraction:
	xor bp,bp		; reset negative sign flag
	sub cx,bx
	jmp scan		; find next number or end...


helpmsg	db "Usage: ADD value [value...]",13,10
	db "Returns (sum of signed values) modulo 256 in errorlevel.",13,10
	db "$"

overflowmsg	db "Numbers must be in -32767 to 32767 range.",13,10,"$"
wrongcharmsg	db "Non-digit found in number.",13,10,"$"

resultmsg	db "Sum of your "
numargs		db "?? values is:",13,10
thevalue	db " ?????",13,10,"$"

